diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/v4traceroute.cc ns-3.42/src/internet-apps/model/v4traceroute.cc
--- ns-3.41/src/internet-apps/model/v4traceroute.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/v4traceroute.cc	2024-05-29 15:29:46.952073000 -0700
@@ -45,46 +45,53 @@
 TypeId
 V4TraceRoute::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::V4TraceRoute")
-                            .SetParent<Application>()
-                            .SetGroupName("Internet-Apps")
-                            .AddConstructor<V4TraceRoute>()
-                            .AddAttribute("Remote",
-                                          "The address of the machine we want to trace.",
-                                          Ipv4AddressValue(),
-                                          MakeIpv4AddressAccessor(&V4TraceRoute::m_remote),
-                                          MakeIpv4AddressChecker())
-                            .AddAttribute("Verbose",
-                                          "Produce usual output.",
-                                          BooleanValue(true),
-                                          MakeBooleanAccessor(&V4TraceRoute::m_verbose),
-                                          MakeBooleanChecker())
-                            .AddAttribute("Interval",
-                                          "Wait interval between sent packets.",
-                                          TimeValue(Seconds(0)),
-                                          MakeTimeAccessor(&V4TraceRoute::m_interval),
-                                          MakeTimeChecker())
-                            .AddAttribute("Size",
-                                          "The number of data bytes to be sent, real packet will "
-                                          "be 8 (ICMP) + 20 (IP) bytes longer.",
-                                          UintegerValue(56),
-                                          MakeUintegerAccessor(&V4TraceRoute::m_size),
-                                          MakeUintegerChecker<uint32_t>())
-                            .AddAttribute("MaxHop",
-                                          "The maximum number of hops to trace.",
-                                          UintegerValue(30),
-                                          MakeUintegerAccessor(&V4TraceRoute::m_maxTtl),
-                                          MakeUintegerChecker<uint32_t>())
-                            .AddAttribute("ProbeNum",
-                                          "The number of packets send to each hop.",
-                                          UintegerValue(3),
-                                          MakeUintegerAccessor(&V4TraceRoute::m_maxProbes),
-                                          MakeUintegerChecker<uint16_t>())
-                            .AddAttribute("Timeout",
-                                          "The waiting time for a route response before a timeout.",
-                                          TimeValue(Seconds(5)),
-                                          MakeTimeAccessor(&V4TraceRoute::m_waitIcmpReplyTimeout),
-                                          MakeTimeChecker());
+    static TypeId tid =
+        TypeId("ns3::V4TraceRoute")
+            .SetParent<Application>()
+            .SetGroupName("Internet-Apps")
+            .AddConstructor<V4TraceRoute>()
+            .AddAttribute("Remote",
+                          "The address of the machine we want to trace.",
+                          Ipv4AddressValue(),
+                          MakeIpv4AddressAccessor(&V4TraceRoute::m_remote),
+                          MakeIpv4AddressChecker())
+            .AddAttribute("Tos",
+                          "The Type of Service used to send IPv4 packets. "
+                          "All 8 bits of the TOS byte are set (including ECN bits).",
+                          UintegerValue(0),
+                          MakeUintegerAccessor(&V4TraceRoute::m_tos),
+                          MakeUintegerChecker<uint8_t>())
+            .AddAttribute("Verbose",
+                          "Produce usual output.",
+                          BooleanValue(true),
+                          MakeBooleanAccessor(&V4TraceRoute::m_verbose),
+                          MakeBooleanChecker())
+            .AddAttribute("Interval",
+                          "Wait interval between sent packets.",
+                          TimeValue(Seconds(0)),
+                          MakeTimeAccessor(&V4TraceRoute::m_interval),
+                          MakeTimeChecker())
+            .AddAttribute("Size",
+                          "The number of data bytes to be sent, real packet will "
+                          "be 8 (ICMP) + 20 (IP) bytes longer.",
+                          UintegerValue(56),
+                          MakeUintegerAccessor(&V4TraceRoute::m_size),
+                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute("MaxHop",
+                          "The maximum number of hops to trace.",
+                          UintegerValue(30),
+                          MakeUintegerAccessor(&V4TraceRoute::m_maxTtl),
+                          MakeUintegerChecker<uint32_t>())
+            .AddAttribute("ProbeNum",
+                          "The number of packets send to each hop.",
+                          UintegerValue(3),
+                          MakeUintegerAccessor(&V4TraceRoute::m_maxProbes),
+                          MakeUintegerChecker<uint16_t>())
+            .AddAttribute("Timeout",
+                          "The waiting time for a route response before a timeout.",
+                          TimeValue(Seconds(5)),
+                          MakeTimeAccessor(&V4TraceRoute::m_waitIcmpReplyTimeout),
+                          MakeTimeChecker());
     return tid;
 }
 
@@ -121,6 +128,8 @@
     NS_LOG_LOGIC("Application started");
     m_started = Simulator::Now();
 
+    NS_ABORT_MSG_IF(!m_remote.IsInitialized(), "'Remote' attribute not properly set");
+
     if (m_verbose)
     {
         NS_LOG_UNCOND("Traceroute to " << m_remote << ", " << m_maxTtl << " hops Max, " << m_size
@@ -135,6 +144,7 @@
 
     m_socket = Socket::CreateSocket(GetNode(), TypeId::LookupByName("ns3::Ipv4RawSocketFactory"));
     m_socket->SetAttribute("Protocol", UintegerValue(Icmpv4L4Protocol::PROT_NUMBER));
+    m_socket->SetIpTos(m_tos); // Affects only IPv4 sockets.
 
     NS_ASSERT(m_socket);
     m_socket->SetRecvCallback(MakeCallback(&V4TraceRoute::Receive, this));
@@ -152,12 +162,12 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_next.IsRunning())
+    if (m_next.IsPending())
     {
         m_next.Cancel();
     }
 
-    if (m_waitIcmpReplyTimer.IsRunning())
+    if (m_waitIcmpReplyTimer.IsPending())
     {
         m_waitIcmpReplyTimer.Cancel();
     }
@@ -183,7 +193,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    if (m_next.IsRunning() || m_waitIcmpReplyTimer.IsRunning())
+    if (m_next.IsPending() || m_waitIcmpReplyTimer.IsPending())
     {
         StopApplication();
     }
@@ -412,7 +422,7 @@
 V4TraceRoute::StartWaitReplyTimer()
 {
     NS_LOG_FUNCTION(this);
-    if (!m_waitIcmpReplyTimer.IsRunning())
+    if (!m_waitIcmpReplyTimer.IsPending())
     {
         NS_LOG_LOGIC("Starting WaitIcmpReplyTimer at " << Simulator::Now() << " for "
                                                        << m_waitIcmpReplyTimeout);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/model/v4traceroute.h ns-3.42/src/internet-apps/model/v4traceroute.h
--- ns-3.41/src/internet-apps/model/v4traceroute.h	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/model/v4traceroute.h	2024-05-29 15:29:46.952073000 -0700
@@ -63,10 +63,13 @@
      */
     void Print(Ptr<OutputStreamWrapper> stream);
 
+  protected:
+    void DoDispose() override;
+
   private:
     void StartApplication() override;
     void StopApplication() override;
-    void DoDispose() override;
+
     /**
      * \brief Return the application ID in the node.
      * \returns the application id
@@ -118,6 +121,8 @@
     uint16_t m_maxProbes;
     /// The current TTL value
     uint16_t m_ttl;
+    /// The packets Type of Service
+    uint8_t m_tos;
     /// The maximum Ttl (Max number of hops to trace)
     uint32_t m_maxTtl;
     /// The wait time until the response is considered lost.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/test/dhcp-test.cc ns-3.42/src/internet-apps/test/dhcp-test.cc
--- ns-3.41/src/internet-apps/test/dhcp-test.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/test/dhcp-test.cc	2024-05-29 15:29:46.952073000 -0700
@@ -168,9 +168,9 @@
 };
 
 DhcpTestSuite::DhcpTestSuite()
-    : TestSuite("dhcp", UNIT)
+    : TestSuite("dhcp", Type::UNIT)
 {
-    AddTestCase(new DhcpTestCase, TestCase::QUICK);
+    AddTestCase(new DhcpTestCase, TestCase::Duration::QUICK);
 }
 
 static DhcpTestSuite dhcpTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/test/ipv6-radvd-test.cc ns-3.42/src/internet-apps/test/ipv6-radvd-test.cc
--- ns-3.41/src/internet-apps/test/ipv6-radvd-test.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/test/ipv6-radvd-test.cc	2024-05-29 15:29:46.952073000 -0700
@@ -309,9 +309,9 @@
 };
 
 RadvdTestSuite::RadvdTestSuite()
-    : TestSuite("radvd", UNIT)
+    : TestSuite("radvd", Type::UNIT)
 {
-    AddTestCase(new RadvdTestCase, TestCase::QUICK);
+    AddTestCase(new RadvdTestCase, TestCase::Duration::QUICK);
 }
 
 static RadvdTestSuite radvdTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/internet-apps/test/ping-test.cc ns-3.42/src/internet-apps/test/ping-test.cc
--- ns-3.41/src/internet-apps/test/ping-test.cc	2024-02-09 14:44:07.913790200 -0800
+++ ns-3.42/src/internet-apps/test/ping-test.cc	2024-05-29 15:29:46.952073000 -0700
@@ -567,7 +567,7 @@
 };
 
 PingTestSuite::PingTestSuite()
-    : TestSuite("ping", UNIT)
+    : TestSuite("ping", Type::UNIT)
 {
     // 1. Unlimited pings, no losses, StopApplication () with no packets in flight
     //    Configuration:  Ping::Count = 0,  Ping::Interval = 1s, Ping start
@@ -586,7 +586,7 @@
     testcase1v4->CheckReportReceived(5);
     testcase1v4->CheckTraceTx(5);
     testcase1v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
-    AddTestCase(testcase1v4, TestCase::QUICK);
+    AddTestCase(testcase1v4, TestCase::Duration::QUICK);
 
     auto testcase1v6 = new PingTestCase(
         "1. Unlimited pings, no losses, StopApplication () with no packets in flight IPv6",
@@ -598,7 +598,7 @@
     testcase1v6->CheckReportReceived(5);
     testcase1v6->CheckTraceTx(5);
     testcase1v6->SetDestinationAddress(Ipv6Address("2001:1::200:ff:fe00:2"));
-    AddTestCase(testcase1v6, TestCase::QUICK);
+    AddTestCase(testcase1v6, TestCase::Duration::QUICK);
 
     // 2. Unlimited pings, no losses, StopApplication () with 1 packet in flight
     // Configuration:  Ping::Count = 0,  Ping::Interval = 1s, Ping start time =
@@ -617,7 +617,7 @@
     testcase2v4->CheckReportTransmitted(1);
     testcase2v4->CheckReportReceived(0);
     testcase1v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
-    AddTestCase(testcase2v4, TestCase::QUICK);
+    AddTestCase(testcase2v4, TestCase::Duration::QUICK);
 
     auto testcase2v6 = new PingTestCase(
         "2. Unlimited pings, no losses, StopApplication () with 1 packet in flight IPv6",
@@ -628,7 +628,7 @@
     testcase2v6->CheckReportTransmitted(1);
     testcase2v6->CheckReportReceived(0);
     testcase2v6->SetDestinationAddress(Ipv6Address("2001:1::200:ff:fe00:2"));
-    AddTestCase(testcase2v6, TestCase::QUICK);
+    AddTestCase(testcase2v6, TestCase::Duration::QUICK);
 
     // 3. Test for operation of count attribute and the resulting StopApplication time after all
     // pings were received. Limited pings, no losses, StopApplication () with no packet in flight
@@ -657,7 +657,7 @@
     testcase3v4->CheckReportTime(MicroSeconds(2020001));
     testcase3v4->CheckTraceTx(expectedTx);
     testcase3v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
-    AddTestCase(testcase3v4, TestCase::QUICK);
+    AddTestCase(testcase3v4, TestCase::Duration::QUICK);
 
     auto testcase3v6 = new PingTestCase("3. Test for operation of count attribute and exit "
                                         "time after all pings were received, IPv6",
@@ -671,7 +671,7 @@
     testcase3v6->CheckReportTime(MicroSeconds(2020001));
     testcase3v6->CheckTraceTx(expectedTx);
     testcase3v6->SetDestinationAddress(Ipv6Address("2001:1::200:ff:fe00:2"));
-    AddTestCase(testcase3v6, TestCase::QUICK);
+    AddTestCase(testcase3v6, TestCase::Duration::QUICK);
 
     // 4. Test for the operation of interval attribute for IPv4
     // Unlimited pings, no losses, StopApplication () with no packet in flight
@@ -692,7 +692,7 @@
     testcase4v4->CheckReportTransmitted(2);
     testcase4v4->CheckReportReceived(2);
     testcase4v4->SetDestinationAddress(Ipv4Address("10.0.0.2"));
-    AddTestCase(testcase4v4, TestCase::QUICK);
+    AddTestCase(testcase4v4, TestCase::Duration::QUICK);
 
     auto testcase4v6 =
         new PingTestCase("4. Test for the operation of interval attribute for IPv6", USEIPV6_TRUE);
@@ -703,7 +703,7 @@
     testcase4v6->CheckReportTransmitted(2);
     testcase4v6->CheckReportReceived(2);
     testcase4v6->SetDestinationAddress(Ipv6Address("2001:1::200:ff:fe00:2"));
-    AddTestCase(testcase4v6, TestCase::QUICK);
+    AddTestCase(testcase4v6, TestCase::Duration::QUICK);
 
     // 5. Test for behavior of pinging an unreachable host when the
     //    network does not send an ICMP unreachable message.
@@ -730,7 +730,7 @@
     testcase5v4->CheckReportTransmitted(5);
     testcase5v4->CheckReportReceived(0);
     testcase5v4->CheckReportLoss(100);
-    AddTestCase(testcase5v4, TestCase::QUICK);
+    AddTestCase(testcase5v4, TestCase::Duration::QUICK);
 
     auto testcase5v6 =
         new PingTestCase("5. Test for behavior of ping to unreachable IPv6 address", USEIPV6_TRUE);
@@ -740,7 +740,7 @@
     testcase5v6->CheckReportTransmitted(5);
     testcase5v6->CheckReportReceived(0);
     testcase5v6->CheckReportLoss(100);
-    AddTestCase(testcase5v6, TestCase::QUICK);
+    AddTestCase(testcase5v6, TestCase::Duration::QUICK);
 
     // 6. Test for behavior of pinging an broadcast (or multicast) address.
     // Limited pings, no losses, StopApplication () with no packet in flight
@@ -763,7 +763,7 @@
     testcase6v4->CheckReportTransmitted(5);
     testcase6v4->CheckReportReceived(5);
     testcase6v4->CheckReportLoss(0);
-    AddTestCase(testcase6v4, TestCase::QUICK);
+    AddTestCase(testcase6v4, TestCase::Duration::QUICK);
 
     auto testcase6v6 =
         new PingTestCase("6. Test for behavior of ping to all-nodes multicast IPv6 address",
@@ -774,7 +774,7 @@
     testcase6v6->CheckReportTransmitted(5);
     testcase6v6->CheckReportReceived(5);
     testcase6v6->CheckReportLoss(0);
-    AddTestCase(testcase6v6, TestCase::QUICK);
+    AddTestCase(testcase6v6, TestCase::Duration::QUICK);
 
     // 7. Test behavior of first reply lost in a count-limited configuration.
     // Limited pings, no losses, StopApplication () with no packet in flight
@@ -803,7 +803,7 @@
     testcase7v4->CheckReportReceived(2);
     testcase7v4->CheckReportLoss(33); // 33%
     testcase7v4->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase7v4, TestCase::QUICK);
+    AddTestCase(testcase7v4, TestCase::Duration::QUICK);
 
     auto testcase7v6 = new PingTestCase(
         "7. Test behavior of first reply lost in a count-limited configuration, IPv6",
@@ -819,7 +819,7 @@
     testcase7v6->CheckReportReceived(2);
     testcase7v6->CheckReportLoss(33); // 33%
     testcase7v6->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase7v6, TestCase::QUICK);
+    AddTestCase(testcase7v6, TestCase::Duration::QUICK);
 
     // 8. Test behavior of second reply lost in a count-limited configuration.
     // Limited pings, no losses, StopApplication () with no packet in flight
@@ -848,7 +848,7 @@
     testcase8v4->CheckReportReceived(2);
     testcase8v4->CheckReportLoss(33); // 33%
     testcase8v4->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase8v4, TestCase::QUICK);
+    AddTestCase(testcase8v4, TestCase::Duration::QUICK);
 
     auto testcase8v6 = new PingTestCase(
         "8. Test behavior of second reply lost in a count-limited configuration, IPv6",
@@ -864,7 +864,7 @@
     testcase8v6->CheckReportReceived(2);
     testcase8v6->CheckReportLoss(33); // 33%
     testcase8v6->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase8v6, TestCase::QUICK);
+    AddTestCase(testcase8v6, TestCase::Duration::QUICK);
 
     // 9. Test behavior of last reply lost in a count-limited configuration.
     // Limited pings, no losses, StopApplication () with no packet in flight
@@ -893,7 +893,7 @@
     testcase9v4->CheckReportReceived(2);
     testcase9v4->CheckReportLoss(33); // 33%
     testcase9v4->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase9v4, TestCase::QUICK);
+    AddTestCase(testcase9v4, TestCase::Duration::QUICK);
 
     auto testcase9v6 = new PingTestCase(
         "9. Test behavior of last reply lost in a count-limited configuration, IPv6",
@@ -909,7 +909,7 @@
     testcase9v6->CheckReportReceived(2);
     testcase9v6->CheckReportLoss(33); // 33%
     testcase9v6->CheckReportTime(MicroSeconds(3040000));
-    AddTestCase(testcase9v6, TestCase::QUICK);
+    AddTestCase(testcase9v6, TestCase::Duration::QUICK);
 
 #ifdef NOTYET
     //
@@ -933,7 +933,7 @@
     testcase10v4->CheckReportTransmitted(1);
     testcase10v4->CheckReportReceived(1);
     testcase10v4->CheckReportTime(MicroSeconds(1020028));
-    AddTestCase(testcase10v4, TestCase::QUICK);
+    AddTestCase(testcase10v4, TestCase::Duration::QUICK);
 #endif
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-active-scan.cc ns-3.42/src/lr-wpan/examples/lr-wpan-active-scan.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-active-scan.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-active-scan.cc	2024-05-29 15:29:46.972073300 -0700
@@ -52,11 +52,12 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 static void
 ScanConfirm(Ptr<LrWpanNetDevice> device, MlmeScanConfirmParams params)
 {
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << "| Active scan status SUCCESSFUL (Completed)"
                   << "\n";
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.42/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2024-05-29 15:29:46.972073300 -0700
@@ -49,6 +49,7 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 NodeContainer nodes;
 NodeContainer coordinators;
@@ -88,7 +89,7 @@
     // with the highest LQI value obtained from a passive scan and make
     // sure this coordinator allows association.
 
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         // Select the coordinator with the highest LQI from the PAN Descriptor List
         int maxLqi = 0;
@@ -137,16 +138,16 @@
                     CapabilityField capability;
 
                     if (params.m_panDescList[panDescIndex].m_coorAddrMode ==
-                        LrWpanAddressMode::SHORT_ADDR)
+                        AddressMode::SHORT_ADDR)
                     {
-                        assocParams.m_coordAddrMode = LrWpanAddressMode::SHORT_ADDR;
+                        assocParams.m_coordAddrMode = AddressMode::SHORT_ADDR;
                         assocParams.m_coordShortAddr =
                             params.m_panDescList[panDescIndex].m_coorShortAddr;
                         capability.SetShortAddrAllocOn(true);
                     }
-                    else if (assocParams.m_coordAddrMode == LrWpanAddressMode::EXT_ADDR)
+                    else if (assocParams.m_coordAddrMode == AddressMode::EXT_ADDR)
                     {
-                        assocParams.m_coordAddrMode = LrWpanAddressMode::EXT_ADDR;
+                        assocParams.m_coordAddrMode = AddressMode::EXT_ADDR;
                         assocParams.m_coordExtAddr =
                             params.m_panDescList[panDescIndex].m_coorExtAddr;
                         assocParams.m_coordShortAddr = Mac16Address("ff:fe");
@@ -209,7 +210,7 @@
     MlmeAssociateResponseParams assocRespParams;
 
     assocRespParams.m_extDevAddr = params.m_extDevAddr;
-    assocRespParams.m_status = LrWpanMacStatus::SUCCESS;
+    assocRespParams.m_status = MacStatus::SUCCESS;
     CapabilityField capability;
     capability.SetCapability(params.capabilityInfo);
 
@@ -248,14 +249,14 @@
     // and is only here for demonstration purposes.
     switch (params.m_status)
     {
-    case LrWpanMacStatus::TRANSACTION_EXPIRED:
+    case MacStatus::TRANSACTION_EXPIRED:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
                   << " MLME-comm-status.indication: Transaction for device " << params.m_dstExtAddr
                   << " EXPIRED in pending transaction list\n";
         break;
-    case LrWpanMacStatus::NO_ACK:
+    case MacStatus::NO_ACK:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
@@ -263,7 +264,7 @@
                   << " device registered in the pending transaction list\n";
         break;
 
-    case LrWpanMacStatus::CHANNEL_ACCESS_FAILURE:
+    case MacStatus::CHANNEL_ACCESS_FAILURE:
         std::cout << Simulator::Now().As(Time::S) << " Coordinator " << device->GetNode()->GetId()
                   << " [" << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
@@ -282,7 +283,7 @@
     // Used by device higher layer to inform the results of a
     // association procedure from its mac layer.This is implemented by other protocol stacks
     // and is only here for demonstration purposes.
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -292,7 +293,7 @@
                   << " | CoordShort: " << device->GetMac()->GetCoordShortAddress()
                   << " | CoordExt: " << device->GetMac()->GetCoordExtAddress() << ")\n";
     }
-    else if (params.m_status == LrWpanMacStatus::NO_ACK)
+    else if (params.m_status == MacStatus::NO_ACK)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -311,7 +312,7 @@
 static void
 PollConfirm(Ptr<LrWpanNetDevice> device, MlmePollConfirmParams params)
 {
-    if (params.m_status == LrWpanMacStatus::CHANNEL_ACCESS_FAILURE)
+    if (params.m_status == MacStatus::CHANNEL_ACCESS_FAILURE)
     {
         std::cout
             << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
@@ -319,14 +320,14 @@
             << device->GetMac()->GetExtendedAddress() << "]"
             << " MLME-poll.confirm:  CHANNEL ACCESS problem when sending a data request command.\n";
     }
-    else if (params.m_status == LrWpanMacStatus::NO_ACK)
+    else if (params.m_status == MacStatus::NO_ACK)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
                   << device->GetMac()->GetExtendedAddress() << "]"
                   << " MLME-poll.confirm: Data Request Command FAILED (NO ACK).\n";
     }
-    else if (params.m_status != LrWpanMacStatus::SUCCESS)
+    else if (params.m_status != MacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-data.cc ns-3.42/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-data.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-data.cc	2024-05-29 15:29:46.972073300 -0700
@@ -37,6 +37,7 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 /**
  * Function called when a Data indication is invoked
@@ -69,8 +70,8 @@
 static void
 StateChangeNotification(std::string context,
                         Time now,
-                        LrWpanPhyEnumeration oldState,
-                        LrWpanPhyEnumeration newState)
+                        PhyEnumeration oldState,
+                        PhyEnumeration newState)
 {
     NS_LOG_UNCOND(context << " state change at " << now.As(Time::S) << " from "
                           << LrWpanHelper::LrWpanPhyEnumerationPrinter(oldState) << " to "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-ed-scan.cc ns-3.42/src/lr-wpan/examples/lr-wpan-ed-scan.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-ed-scan.cc	2024-05-29 15:29:46.972073300 -0700
@@ -52,11 +52,12 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 static void
 ScanConfirm(MlmeScanConfirmParams params)
 {
-    if (params.m_status == LrWpanMacStatus::SUCCESS && params.m_scanType == MLMESCAN_ED)
+    if (params.m_status == MacStatus::SUCCESS && params.m_scanType == MLMESCAN_ED)
     {
         std::cout << Simulator::Now().As(Time::S) << "| Scan status SUCCESSFUL\n";
         std::cout << "Results for Energy Scan:"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.42/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2024-05-29 15:29:46.972073300 -0700
@@ -65,6 +65,7 @@
 #include <vector>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 uint32_t g_packetsReceived = 0; //!< number of packets received
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-error-model-plot.cc ns-3.42/src/lr-wpan/examples/lr-wpan-error-model-plot.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-error-model-plot.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-error-model-plot.cc	2024-05-29 15:29:46.972073300 -0700
@@ -32,6 +32,7 @@
 #include <vector>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 NS_LOG_COMPONENT_DEFINE("LrWpanErrorModelPlot");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-mlme.cc ns-3.42/src/lr-wpan/examples/lr-wpan-mlme.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-mlme.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-mlme.cc	2024-05-29 15:29:46.972073300 -0700
@@ -45,6 +45,7 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 void
 BeaconIndication(MlmeBeaconNotifyIndicationParams params)
@@ -64,7 +65,7 @@
 {
     // In the case of transmissions with the Ack flag activated, the transaction is only
     // successful if the Ack was received.
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         NS_LOG_UNCOND(Simulator::Now().GetSeconds() << " secs | Transmission successfully sent");
     }
@@ -80,7 +81,7 @@
 void
 StartConfirm(MlmeStartConfirmParams params)
 {
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         NS_LOG_UNCOND(Simulator::Now().GetSeconds() << "Beacon status SUCCESSFUL");
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-orphan-scan.cc ns-3.42/src/lr-wpan/examples/lr-wpan-orphan-scan.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2024-05-29 15:29:46.972073300 -0700
@@ -64,11 +64,12 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 static void
 ScanConfirm(Ptr<LrWpanNetDevice> device, MlmeScanConfirmParams params)
 {
-    if (params.m_status == LrWpanMacStatus::SUCCESS)
+    if (params.m_status == MacStatus::SUCCESS)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
@@ -76,7 +77,7 @@
                   << "] MLME-SCAN.confirm: Active scan status SUCCESSFUL "
                   << "(Coordinator found and address assigned) \n";
     }
-    else if (params.m_status == LrWpanMacStatus::NO_BEACON)
+    else if (params.m_status == MacStatus::NO_BEACON)
     {
         std::cout << Simulator::Now().As(Time::S) << " Node " << device->GetNode()->GetId() << " ["
                   << device->GetMac()->GetShortAddress() << " | "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-packet-print.cc ns-3.42/src/lr-wpan/examples/lr-wpan-packet-print.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-packet-print.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-packet-print.cc	2024-05-29 15:29:46.972073300 -0700
@@ -22,6 +22,7 @@
 #include <iostream>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 int
 main(int argc, char* argv[])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-per-plot.cc ns-3.42/src/lr-wpan/examples/lr-wpan-per-plot.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-per-plot.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-per-plot.cc	2024-05-29 15:29:46.976073300 -0700
@@ -43,6 +43,7 @@
 #include <ns3/spectrum-module.h>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 uint32_t g_packetsReceived = 0; //!< number of packets received
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/lr-wpan/examples/lr-wpan-phy-test.cc ns-3.42/src/lr-wpan/examples/lr-wpan-phy-test.cc
--- ns-3.41/src/lr-wpan/examples/lr-wpan-phy-test.cc	2024-02-09 14:44:07.953790400 -0800
+++ ns-3.42/src/lr-wpan/examples/lr-wpan-phy-test.cc	2024-05-29 15:29:46.976073300 -0700
@@ -27,13 +27,14 @@
 #include <ns3/test.h>
 
 using namespace ns3;
+using namespace ns3::lrwpan;
 
 /**
  * Function called when a the PHY state change is confirmed
  * \param status PHY state
  */
 void
-GetSetTRXStateConfirm(LrWpanPhyEnumeration status)
+GetSetTRXStateConfirm(PhyEnumeration status)
 {
     NS_LOG_UNCOND("At: " << Simulator::Now() << " Received Set TRX Confirm: " << status);
 }
